commit bc6059e257cfef37553bca1b1f0d2ef351ea766a
Author: Patrick Palka <ppalka@redhat.com>
Date:   Sat Jun 19 02:50:13 2021

    libstdc++: Implement LWG 3546 changes to common_iterator
    
    libstdc++-v3/ChangeLog:
    
            * include/bits/stl_iterator.h
            (__detail::__common_iter_use_postfix_proxy): Add
            move_constructible constraint as per LWG 3546.
            (common_iterator::__postfix_proxy): Adjust initializer of
            _M_keep as per LWG 3546.
    
    (cherry picked from commit 4123650bd0ae53153142949ab5305eb48ec86390)

diff --git a/libstdc++-v3/include/bits/stl_iterator.h b/libstdc++-v3/include/bits/stl_iterator.h
index 8768624b7d1..f7309e6bca8 100644
--- a/libstdc++-v3/include/bits/stl_iterator.h
+++ b/libstdc++-v3/include/bits/stl_iterator.h
@@ -1683,7 +1683,8 @@ _GLIBCXX_BEGIN_NAMESPACE_VERSION
     template<typename _It>
       concept __common_iter_use_postfix_proxy
 	= (!requires (_It& __i) { { *__i++ } -> __can_reference; })
-	  && constructible_from<iter_value_t<_It>, iter_reference_t<_It>>;
+	  && constructible_from<iter_value_t<_It>, iter_reference_t<_It>>
+	  && move_constructible<iter_value_t<_It>>;
   } // namespace __detail
 
   /// An iterator/sentinel adaptor for representing a non-common range.
@@ -1726,7 +1727,7 @@ _GLIBCXX_BEGIN_NAMESPACE_VERSION
       iter_value_t<_It> _M_keep;
 
       __postfix_proxy(iter_reference_t<_It>&& __x)
-      : _M_keep(std::move(__x)) { }
+      : _M_keep(std::forward<iter_reference_t<_It>>(__x)) { }
 
       friend class common_iterator;
 

